local name, addon = ...
addon['name'] = name
addon['parentName'] = name
addon['inits'] = addon['inits'] or {}
addon['defaults'] = {
	['profile'] = {
		["zz_Skeletontoggle"] = false,
	}
}
local brokers = {}

addon['RegisterBroker'] = function(brokerName, brokerFunc)
	brokers[brokerName] = brokerFunc
end

addon['PLAYER_ENTERING_WORLD'] = function(self,event,...)
	for broker, func in pairs(brokers) do
		addon['AddConfigEntry'](addon, name,"toggle",broker.."toggle",broker,"Enable/Disable "..broker.." on next reload",1,nil,nil,nil,nil,addon['options']['args'][name])
		if(addon['db']['profile'][broker..'toggle'] or addon['db']['profile'][broker..'toggle'] == nil) then
			func()
		end
	end
	self:UnregisterEvent(event)
end

addon['ADDON_LOADED'] = function(self,event,arg1)
	if(arg1 ~= name) then return end
	addon['db'] = LibStub("AceDB-3.0"):New(name.."DB", addon['defaults'], true)
	addon['db']['profile'][name] = addon['db']['profile'][name] or {}
	addon['InitConfig'](addon, name)
	self:UnregisterEvent(event)
end

addon['RegisterFunc']({'ADDON_LOADED','PLAYER_ENTERING_WORLD'},"OnEvent", function(self, event, ...)
	if(type(addon[event]) == 'function') then
		addon[event](self, event, ...)
	end
end)
addon['inits'][name] = init